diff -ruN freeswan-1.9.orig/pluto/ipsec_doi.c freeswan-1.9/pluto/ipsec_doi.c
--- freeswan-1.9.orig/pluto/ipsec_doi.c	Sun Jan 28 16:03:04 2001
+++ freeswan-1.9/pluto/ipsec_doi.c	Thu May 17 11:09:08 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: ipsec_doi.c,v 1.120 2001/01/28 21:03:04 dhr Exp $
+ * RCSID $Id: ipsec_doi.c,v 1.131 2001/05/08 05:37:21 dhr Exp $
  */
 
 #include <stdio.h>
@@ -49,18 +49,117 @@
 #include "md5.h"
 #include "crypto.h" /* requires sha1.h and md5.h */
 
+#ifdef OPENSSL
+#include "openssl.h"
+#endif
+
 /* MAGIC: perform f, a function that returns notification_t
  * and return from the ENCLOSING stf_status returning function if it fails.
  */
 #define RETURN_STF_FAILURE(f) \
     { int r = (f); if (r != NOTHING_WRONG) return STF_FAIL + r; }
 
+stf_status send_delete(struct state *p2st, ipsec_spi_t *spi, bool ESP);
+static bool encrypt_message(pb_stream *pbs, struct state *st);
+
+/* needed for PGPnet Vendor ID */
+char pgp_vid[] = { 0x4f, 0x70, 0x65, 0x6e,
+		   0x50, 0x47, 0x50, 0x31,
+		   0x30, 0x31, 0x37, 0x31};
+
+/* Compute DH shared secret from our local secret and the peer's public value.
+ * We make the leap that the length should be that of the group
+ * (see quoted passage at start of ACCEPT_KE).
+ */
+static void
+compute_dh_shared(struct state *st, const chunk_t g
+, const struct oakley_group_desc *group)
+{
+    MP_INT mp_g, mp_shared;
+
+    passert(st->st_sec_in_use);
+    n_to_mpz(&mp_g, g.ptr, g.len);
+    mpz_init(&mp_shared);
+    mpz_powm(&mp_shared, &mp_g, &st->st_sec, group->modulus);
+    mpz_clear(&mp_g);
+    st->st_shared = mpz_to_n(&mp_shared, group->bytes);
+    mpz_clear(&mp_shared);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+	loglog(RC_LOG_SERIOUS, "shared DH secret has leading zero -- triggers Pluto 1.0 bug");
+#endif
+    DBG_cond_dump_chunk(DBG_CRYPT, "DH shared secret:\n", st->st_shared);
+}
+
+#ifdef OPENSSL
+static bool
+build_and_ship_KE_rpk(struct state *st, bool init,
+                    chunk_t *g,
+                    const struct oakley_group_desc *group, pb_stream *outs,
+                    u_int8_t np)
+{
+  keysched *ks;
+  u_char *iv;
+  chunk_t op;
+  bool res;
+
+    if (!st->st_sec_in_use)
+    {
+      u_char tmp[LOCALSECRETSIZE];
+      MP_INT mp_g;
+
+      get_rnd_bytes(tmp, LOCALSECRETSIZE);
+      st->st_sec_in_use = TRUE;
+      n_to_mpz(&st->st_sec, tmp, LOCALSECRETSIZE);
+
+      mpz_init(&mp_g);
+      mpz_powm(&mp_g, &groupgenerator, &st->st_sec, group->modulus);
+      *g = mpz_to_n(&mp_g, group->bytes);
+      mpz_clear(&mp_g);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+      if (g->ptr[0] == 0)
+      {
+          /* generate a new secret to avoid this situation */
+          log("regenerating DH private secret to avoid Pluto 1.0 bug"
+              " handling public value with leading zero");
+          mpz_clear(&st->st_sec);
+          st->st_sec_in_use = FALSE;
+          freeanychunk(*g);
+          return build_and_ship_KE_rpk(st, init, g, group, outs, np);
+      }
+#endif
+
+      DBG(DBG_CRYPT,
+      DBG_dump("Local DH secret:\n", tmp, LOCALSECRETSIZE);
+      DBG_dump_chunk("Public DH value sent:\n", *g);
+      );
+    }
+    /* Encrypt the chunk */
+    if (init) {
+      ks = &st->st_ks_i;
+      iv = st->st_ne_i_iv;
+    } else {
+      ks = &st->st_ks_r;
+      iv = st->st_ne_r_iv;
+    }
+    setchunk(op, NULL, 0);
+    if (!encrypt_payload( st, ks, iv, *g, &op )) return FALSE;
+    res = out_generic_chunk(np, &isakmp_keyex_desc, outs, op,
+                          "encrypted keyex value");
+    freeanychunk(op);
+    return res;
+}
+#endif
+
 /* if we haven't already done so, compute a local DH secret (st->st_sec) and
  * the corresponding public value (g).  This is emitted as a KE payload.
+ * KLUDGE: if DODGE_DH_MISSING_ZERO_BUG and we're the responder,
+ * this routine computes the shared secret to see if it would
+ * have a leading zero.  If so, we try again.
  */
 static bool
 build_and_ship_KE(struct state *st, chunk_t *g
-    , const struct oakley_group_desc *group, pb_stream *outs, u_int8_t np)
+, const struct oakley_group_desc *group, pb_stream *outs, u_int8_t np)
 {
     if (!st->st_sec_in_use)
     {
@@ -89,36 +188,13 @@
 #endif
 
 	DBG(DBG_CRYPT,
-	    DBG_dump("Local DH secret:\n", tmp, LOCALSECRETSIZE);
-	    DBG_dump_chunk("Public DH value sent:\n", *g));
+	DBG_dump("Local DH secret:\n", tmp, LOCALSECRETSIZE);
+	DBG_dump_chunk("Public DH value sent:\n", *g);
+	);
     }
     return out_generic_chunk(np, &isakmp_keyex_desc, outs, *g, "keyex value");
 }
 
-/* Compute DH shared secret from our local secret and the peer's public value.
- * We make the leap that the length should be that of the group
- * (see quoted passage at start of ACCEPT_KE).
- */
-static void
-compute_dh_shared(struct state *st, const chunk_t g
-    , const struct oakley_group_desc *group)
-{
-    MP_INT mp_g, mp_shared;
-
-    passert(st->st_sec_in_use);
-    n_to_mpz(&mp_g, g.ptr, g.len);
-    mpz_init(&mp_shared);
-    mpz_powm(&mp_shared, &mp_g, &st->st_sec, group->modulus);
-    mpz_clear(&mp_g);
-    st->st_shared = mpz_to_n(&mp_shared, group->bytes);
-    mpz_clear(&mp_shared);
-#ifdef DODGE_DH_MISSING_ZERO_BUG
-    if (st->st_shared.ptr[0] == 0)
-	loglog(RC_LOG_SERIOUS, "shared DH secret has leading zero -- triggers Pluto 1.0 bug");
-#endif
-    DBG_cond_dump_chunk(DBG_CRYPT, "DH shared secret:\n", st->st_shared);
-}
-
 /* accept_ke
  *
  * Check and accept DH public value (Gi or Gr) from peer's message.
@@ -131,7 +207,8 @@
  *     values to interoperate with old Plutos.  This should change some day.
  */
 static notification_t
-accept_KE(chunk_t *dest, const char *val_name, const struct oakley_group_desc *gr
+accept_KE(chunk_t *dest, const char *val_name
+, const struct oakley_group_desc *gr
 , pb_stream *pbs)
 {
     if (pbs_left(pbs) != gr->bytes)
@@ -155,7 +232,8 @@
  * Extends ACCEPT_PFS to check whether KE is allowed or required.
  */
 static notification_t
-accept_PFS_KE(struct msg_digest *md, chunk_t *dest, const char *val_name, const char *msg_name)
+accept_PFS_KE(struct msg_digest *md, chunk_t *dest
+, const char *val_name, const char *msg_name)
 {
     struct state *st = md->st;
     struct payload_digest *const ke_pd = md->chain[ISAKMP_NEXT_KE];
@@ -187,13 +265,31 @@
 }
 
 static bool
-build_and_ship_nonce(chunk_t *n, pb_stream *outs, u_int8_t np, const char *name)
+build_and_ship_nonce(chunk_t *n, pb_stream *outs, u_int8_t np
+, const char *name)
 {
     setchunk(*n, alloc_bytes(DEFAULT_NONCE_SIZE, name), DEFAULT_NONCE_SIZE);
     get_rnd_bytes(n->ptr, DEFAULT_NONCE_SIZE);
     return out_generic_chunk(np, &isakmp_nonce_desc, outs, *n, name);
 }
 
+#ifdef OPENSSL
+static bool
+build_and_ship_nonce_pk(struct state *st, chunk_t *n, pb_stream *outs, u_int8_t np, const char *name)
+{
+    chunk_t c;
+
+    setchunk(*n, alloc_bytes(DEFAULT_NONCE_SIZE, name), DEFAULT_NONCE_SIZE);
+    get_rnd_bytes(n->ptr, DEFAULT_NONCE_SIZE);
+    c.len = n->len;
+    c.ptr = clone_bytes(n->ptr, c.len, name);
+    if (! pubkey_encrypt_chunk(&c, st)) {
+      return FALSE;
+    }
+    return out_generic_chunk(np, &isakmp_nonce_desc, outs, c, name);
+}
+#endif
+
 /*
  * Send a notification to the peer. We could make a decision on
  * whether to send the notification, based on the type and the
@@ -203,64 +299,181 @@
  * XXX Not modified to support ip_address and related (IPv4+IPv6) functions.
  */
 #if 0 /* not currently used */
-//static void
-//send_notification(int sock,
-//    u_int16_t type,
-//    u_char *spi,
-//    u_char spilen,
-//    u_char protoid,
-//    u_char *icookie,
-//    u_char *rcookie,
-//    msgid_t /*network order*/ msgid,
-//    struct sockaddr sa)
-//{
-//    u_char buffer[sizeof(struct isakmp_hdr) +
-//		 sizeof(struct isakmp_notification)];
-//    struct isakmp_hdr *isa = (struct isakmp_hdr *) buffer;
-//    struct isakmp_notification *isan = (struct isakmp_notification *)
-//				       (buffer + sizeof(struct isakmp_hdr));
-//
-//    memset(buffer, '\0', sizeof(struct isakmp_hdr) +
-//	  sizeof(struct isakmp_notification));
-//
-//    if (icookie != (u_char *) NULL)
-//	memcpy(isa->isa_icookie, icookie, COOKIE_SIZE);
-//
-//    if (rcookie != (u_char *) NULL)
-//	memcpy(isa->isa_rcookie, rcookie, COOKIE_SIZE);
-//
-//    /* Standard header */
-//    isa->isa_np = ISAKMP_NEXT_N;
-//    isa->isa_version = ISAKMP_MAJOR_VERSION << ISA_MAJ_SHIFT | ISAKMP_MINOR_VERSION;
-//    isa->isa_xchg = ISAKMP_XCHG_INFO;
-//    isa->isa_msgid = msgid;
-//    isa->isa_length = htonl(sizeof(struct isakmp_hdr) +
-//			    sizeof(struct isakmp_notification) +
-//			    spilen);
-//
-//    /* Notification header */
-//    isan->isan_type = htons(type);
-//    isan->isan_doi = htonl(ISAKMP_DOI_IPSEC);
-//    isan->isan_length = htons(sizeof(struct isakmp_notification) + spilen);
-//    isan->isan_spisize = spilen;
-//    memcpy((u_char *)isan + sizeof(struct isakmp_notification), spi, spilen);
-//    isan->isan_protoid = protoid;
-//
-//    DBG(DBG_CONTROL, DBG_log("sending INFO type %s to %s",
-//	enum_show(&notification_names, type),
-//	show_sa(&sa)));
-//
-//    if (sendto(sock, buffer, ntohl(isa->isa_length), 0, &sa,
-//	       sizeof(sa)) != ntohl(isa->isa_length))
-//	log_errno((e, "sendto() failed in send_notification() to %s",
-//	    show_sa(&sa)));
-//    else
-//    {
-//	DBG(DBG_CONTROL, DBG_log("transmitted %d bytes", ntohl(isa->isa_length)));
-//    }
-//}
+static void
+send_notification(int sock,
+    u_int16_t type,
+    u_char *spi,
+    u_char spilen,
+    u_char protoid,
+    u_char *icookie,
+    u_char *rcookie,
+    msgid_t /*network order*/ msgid,
+    struct sockaddr sa)
+{
+    u_char buffer[sizeof(struct isakmp_hdr) +
+		 sizeof(struct isakmp_notification)];
+    struct isakmp_hdr *isa = (struct isakmp_hdr *) buffer;
+    struct isakmp_notification *isan = (struct isakmp_notification *)
+				       (buffer + sizeof(struct isakmp_hdr));
+
+    memset(buffer, '\0', sizeof(struct isakmp_hdr) +
+	  sizeof(struct isakmp_notification));
+
+    if (icookie != (u_char *) NULL)
+	memcpy(isa->isa_icookie, icookie, COOKIE_SIZE);
+
+    if (rcookie != (u_char *) NULL)
+	memcpy(isa->isa_rcookie, rcookie, COOKIE_SIZE);
+
+    /* Standard header */
+    isa->isa_np = ISAKMP_NEXT_N;
+    isa->isa_version = ISAKMP_MAJOR_VERSION << ISA_MAJ_SHIFT | ISAKMP_MINOR_VERSION;
+    isa->isa_xchg = ISAKMP_XCHG_INFO;
+    isa->isa_msgid = msgid;
+    isa->isa_length = htonl(sizeof(struct isakmp_hdr) +
+			    sizeof(struct isakmp_notification) +
+			    spilen);
+
+    /* Notification header */
+    isan->isan_type = htons(type);
+    isan->isan_doi = htonl(ISAKMP_DOI_IPSEC);
+    isan->isan_length = htons(sizeof(struct isakmp_notification) + spilen);
+    isan->isan_spisize = spilen;
+    memcpy((u_char *)isan + sizeof(struct isakmp_notification), spi, spilen);
+    isan->isan_protoid = protoid;
+
+    DBG(DBG_CONTROL, DBG_log("sending INFO type %s to %s",
+	enum_show(&notification_names, type),
+	show_sa(&sa)));
+
+    if (sendto(sock, buffer, ntohl(isa->isa_length), 0, &sa,
+	       sizeof(sa)) != ntohl(isa->isa_length))
+	log_errno((e, "sendto() failed in send_notification() to %s",
+	    show_sa(&sa)));
+    else
+    {
+	DBG(DBG_CONTROL, 
+	DBG_log("transmitted %d bytes", ntohl(isa->isa_length));
+	);
+    }
+}
 #endif /* not currently used */
 
+
+stf_status
+send_delete(struct state *p2st, ipsec_spi_t *spi, bool ESP)
+{
+     
+     pb_stream reply_pbs;
+     pb_stream r_hdr_pbs;
+     msgid_t	msgid;
+     u_char 	old_new_iv[MAX_DIGEST_LEN];
+     u_char 	old_iv[MAX_DIGEST_LEN];         
+     u_char buffer[8192];
+     struct state *p1st;
+     
+     u_char spilen = sizeof(ipsec_spi_t);
+     u_char
+ 	*r_hashval,	/* where in reply to jam hash value */
+ 	*r_hash_start;	/* start of what is to be hashed */
+     
+     memset(buffer, '\0', sizeof(buffer));
+     init_pbs(&reply_pbs, buffer, sizeof(buffer), "delete msg");
+ 
+     /* find the related P1-State to the calling P2-state */
+     p1st = find_state(p2st->st_icookie, p2st->st_rcookie, 
+     			&(p2st->st_connection->that.host_addr), 0);
+     if (p1st == NULL) 
+     {
+ 	DBG_log("no phase 1 state where one should be");
+	return STF_INTERNAL_ERROR;
+     }
+ 
+     msgid = generate_msgid(p1st);
+
+     /* HDR* */
+     {
+ 	struct isakmp_hdr hdr;
+ 
+ 	hdr.isa_version = ISAKMP_MAJOR_VERSION << ISA_MAJ_SHIFT | ISAKMP_MINOR_VERSION;
+ 	hdr.isa_np = ISAKMP_NEXT_HASH;
+ 	hdr.isa_xchg = ISAKMP_XCHG_INFO;
+ 	hdr.isa_msgid = msgid;
+ 	hdr.isa_flags = ISAKMP_FLAG_ENCRYPTION;
+ 	memcpy(hdr.isa_icookie, p1st->st_icookie, COOKIE_SIZE);
+ 	memcpy(hdr.isa_rcookie, p1st->st_rcookie, COOKIE_SIZE);
+ 	if (!out_struct(&hdr, &isakmp_hdr_desc, &reply_pbs, &r_hdr_pbs))
+ 	    return STF_INTERNAL_ERROR;
+     }
+ 
+     /* HASH -- space to be filled later */
+     {
+ 	pb_stream hash_pbs;
+ 
+ 	if (!out_generic(ISAKMP_NEXT_D, &isakmp_hash_desc, &r_hdr_pbs, &hash_pbs))
+     	    return STF_INTERNAL_ERROR;
+ 	r_hashval = hash_pbs.cur;	/* remember where to plant value */
+ 	if (!out_zero(p1st->st_oakley.hasher->hash_digest_len, &hash_pbs, "HASH(1)"))
+ 	    return STF_INTERNAL_ERROR;
+ 	close_output_pbs(&hash_pbs);
+ 	r_hash_start = r_hdr_pbs.cur;	/* hash from after HASH(1) */
+     }
+ 
+     /* DELETE PAYLOAD */
+     {
+ 	pb_stream del_pbs;
+ 	struct isakmp_delete isad;
+ 	
+        isad.isad_doi = ISAKMP_DOI_IPSEC;
+ 	isad.isad_np = ISAKMP_NEXT_NONE;
+ 	isad.isad_spisize = spilen;
+        if (ESP) isad.isad_protoid = PROTO_IPSEC_ESP;
+        else isad.isad_protoid = PROTO_IPSEC_AH;
+ 	isad.isad_nospi = 0x0001;
+         if (!out_struct(&isad, &isakmp_delete_desc, &r_hdr_pbs, &del_pbs))
+ 	    return STF_INTERNAL_ERROR;
+ 	if (!out_raw(spi, spilen, &del_pbs, "delete payload"))
+ 	    return STF_INTERNAL_ERROR;;
+         close_output_pbs(&del_pbs);
+     }
+     
+     {
+         struct hmac_ctx ctx;
+ 	hmac_init_chunk(&ctx, p1st->st_oakley.hasher, p1st->st_skeyid_a);
+         hmac_update(&ctx, (u_char *) &msgid, sizeof(msgid_t));
+         hmac_update(&ctx, r_hash_start, r_hdr_pbs.cur-r_hash_start);
+ 	hmac_final(r_hashval, &ctx);
+ 
+         DBG(DBG_CRYPT,
+     	    DBG_log("HASH(1) computed:");
+ 	    DBG_dump("", r_hashval, ctx.hmac_digest_len));
+     }
+ 
+     /* save old IV (this prevents from copying a whole new state object 
+      * for NOTIFICATION / DELETE messages we don't need to maintain a state
+      * because there are no retransmissions...
+      */
+      
+     memcpy(old_new_iv, p1st->st_new_iv, p1st->st_new_iv_len);
+     memcpy(old_iv, p1st->st_iv, p1st->st_iv_len);
+     init_phase2_iv(p1st, &msgid);
+ 
+     if(!encrypt_message(&r_hdr_pbs, p1st)) passert(FALSE);
+     
+     clonetochunk(p1st->st_tpacket, reply_pbs.start, pbs_offset(&reply_pbs)
+ 	, "reply packet for main_outI1");
+ 
+     send_packet(p1st, "delete notify");
+     
+     /* get back old IV for this state */
+     memcpy(p1st->st_new_iv, old_new_iv, p1st->st_new_iv_len);
+     memcpy(p1st->st_iv, old_iv, p1st->st_iv_len);    
+     
+     return STF_IGNORE; 
+}
+ 
+
+
 /* The whole message must be a multiple of 4 octets.
  * I'm not sure where this is spelled out, but look at
  * rfc2408 3.6 Transform Payload.
@@ -280,12 +493,11 @@
  * --> HDR;SA
  */
 static stf_status
-main_outI1(
-	int whack_sock,
-	struct connection *c,
-	bool pending_quick,
-	lset_t policy,
-	unsigned long try)
+main_outI1(int whack_sock,
+       struct connection *c,
+       bool pending_quick,
+       lset_t policy,
+       unsigned long try)
 {
     u_char space[8192];	/* NOTE: we assume 8192 is big enough to build the packet */
     pb_stream reply;	/* not actually a reply, but you know what I mean */
@@ -293,6 +505,10 @@
 
     struct state *st;
 
+    DBG(DBG_PARSING,
+    DBG_log("in main_outI1");
+    );
+
     /* set up new state */
     cur_state = st = new_state();
     st->st_connection = c;
@@ -300,7 +516,7 @@
     extra_debugging(c);
 #endif
     st->st_pending_quick = pending_quick;
-    st->st_policy = policy;
+    st->st_policy = policy; 
     st->st_whack_sock = whack_sock;
     st->st_try = try;
     st->st_state = STATE_MAIN_I1;
@@ -318,7 +534,7 @@
     {
 	struct isakmp_hdr hdr;
 
-	memset(&hdr, '\0', sizeof(hdr));	/* default to 0 */
+	memset(&hdr, '\0', sizeof(hdr));        /* default to 0 */
 	hdr.isa_version = ISAKMP_MAJOR_VERSION << ISA_MAJ_SHIFT | ISAKMP_MINOR_VERSION;
 	hdr.isa_np = ISAKMP_NEXT_SA;
 	hdr.isa_xchg = ISAKMP_XCHG_IDPROT;
@@ -345,7 +561,11 @@
 
 	    if (get_RSA_private_key(c) != NULL
 	    && get_his_RSA_public_key(c) != NULL)
+#ifndef OPENSSL
 		auth_policy |= POLICY_RSASIG;
+#else
+		auth_policy |= POLICY_OPENSSL;
+#endif
 	    /* Not clear what we should do if neither is possible.
 	     * Perhaps we should not have entered negotiations at all.
 	     */
@@ -356,6 +576,23 @@
 		return STF_INTERNAL_ERROR;
 	    }
 	}
+
+#ifdef OPENSSL
+if (use_openssl(c)) 
+{
+	loglog(RC_LOG_SERIOUS, "Using OPENSSL sadb.");
+	if (!out_sa(&rbody
+	, &oakley_sadb2[auth_policy >> POLICY_ISAKMP_SHIFT]
+	, st, TRUE, ISAKMP_NEXT_NONE))
+	{
+	    cur_state = NULL;
+	    return STF_INTERNAL_ERROR;
+	}
+}
+else
+{
+#endif /* OPENSSL */
+	loglog(RC_LOG_SERIOUS, "Using standard sadb.");
 	if (!out_sa(&rbody
 	, &oakley_sadb[auth_policy >> POLICY_ISAKMP_SHIFT]
 	, st, TRUE, ISAKMP_NEXT_NONE))
@@ -363,6 +600,10 @@
 	    cur_state = NULL;
 	    return STF_INTERNAL_ERROR;
 	}
+#ifdef OPENSSL
+}
+#endif /* ! OPENSSL */
+
 
 	/* save initiator SA for later HASH */
 	passert(st->st_p1isa.ptr == NULL);	/* no leak!  (MUST be first time) */
@@ -385,7 +626,7 @@
     event_schedule(EVENT_RETRANSMIT, EVENT_RETRANSMIT_DELAY_0, st);
 
     whack_log(RC_NEW_STATE + STATE_MAIN_I1
-	, "%s: initiate", enum_name(&state_names, st->st_state));
+       , "%s: initiate", enum_name(&state_names, st->st_state));
     cur_state = NULL;
     return STF_NO_REPLY;
 }
@@ -414,11 +655,11 @@
     }
     else if (pending_quick)
     {
-	/* ??? we assume that peer_nexthop_sin isn't important:
-	 * we already have it from when we negotiated the ISAKMP SA!
-	 * It isn't clear what to do with the error return.
-	 */
-	(void) quick_outI1(whack_sock, st, c, policy, try);
+       /* ??? we assume that peer_nexthop_sin isn't important:
+        * we already have it from when we negotiated the ISAKMP SA!
+        * It isn't clear what to do with the error return.
+        */
+       (void) quick_outI1(whack_sock, st, c, policy, try);
     }
     else if (whack_sock != NULL_FD)
     {
@@ -443,8 +684,7 @@
 
     if (IS_PHASE1(st->st_state))
     {
-	(void) main_outI1(whack_sock, st->st_connection, st->st_pending_quick
-	    , policy, try);
+        (void) main_outI1(whack_sock, st->st_connection, st->st_pending_quick, policy, try);
     }
     else
     {
@@ -522,6 +762,57 @@
     return TRUE;
 }
 
+#ifdef OPENSSL
+#if 0
+static const chunk_t
+chunk_concat( const chunk_t c1, const chunk_t c2 )
+{
+    chunk_t cc;
+
+    cc.len = c1.len + c2.len;
+    if ((cc.ptr = malloc(cc.len)) != NULL) {
+      memcpy(cc.ptr, c1.ptr, c1.len);
+      memcpy(&(cc.ptr[c1.len]), c2.ptr, c2.len);
+    }
+    return cc;
+}
+#endif
+
+static bool
+skeyid_pke(struct state *st)
+{
+    /* This routine lifted straight from Kai Martius' patches */
+    /* and updated to use chunks */
+    struct hmac_ctx ctx;
+    union hash_ctx ictx;
+    const struct hash_desc *h = st->st_oakley.hasher;
+    u_char *nonce;
+    u_int16_t nonce_len;
+    chunk_t noncechunk, cky_i, cky_r;
+
+    nonce_len = h->hash_digest_len;
+    nonce=alloc_bytes(nonce_len, "nonce in skeyid_pke()");
+
+    h->hash_init(&ictx);
+    h->hash_update(&ictx, st->st_ni.ptr, st->st_ni.len);
+    h->hash_update(&ictx, st->st_nr.ptr, st->st_nr.len);
+    h->hash_final(nonce, &ictx);
+
+    setchunk(noncechunk, nonce, nonce_len);
+    setchunk(cky_i, st->st_icookie, COOKIE_SIZE);
+    setchunk(cky_r, st->st_rcookie, COOKIE_SIZE);
+
+    hmac_init_chunk(&ctx, h, noncechunk);
+    hmac_update_chunk(&ctx, cky_i);
+    hmac_update_chunk(&ctx, cky_r);
+    hmac_final_chunk(st->st_skeyid, "st_skeyid in skeyid_pke()", &ctx);
+
+    free(nonce);
+
+    return TRUE;
+}
+#endif
+
 /* Generate the SKEYID_* and new IV
  * See draft-ietf-ipsec-ike-01.txt 4.1
  */
@@ -542,13 +833,21 @@
 	    break;
 
 	case OAKLEY_DSS_SIG:
-	    /* XXX */
+#ifdef OPENSSL
+          if (!skeyid_digisig(st))
+              return FALSE;
+          break;
+#endif
 
 	case OAKLEY_RSA_ENC:
 	case OAKLEY_RSA_ENC_REV:
 	case OAKLEY_ELGAMAL_ENC:
 	case OAKLEY_ELGAMAL_ENC_REV:
-	    /* XXX */
+#ifdef OPENSSL
+          if (!skeyid_pke(st))
+              return FALSE;
+          break;
+#endif
 
 	default:
 	    exit_log("generate_skeyids_iv(): unsupported authentication method %s",
@@ -737,7 +1036,7 @@
     return ctx.hmac_digest_len;
 }
 
-#if 0	/* only needed for DSS */
+#ifdef OPENSSL
 static void
 main_mode_sha1(struct state *st, u_char *hash_val, size_t *hash_len
 , bool hashi, bool hashus)
@@ -945,6 +1244,13 @@
     switch (st->st_oakley.auth)
     {
     case OAKLEY_PRESHARED_KEY:
+#ifdef OPENSSL
+     case OAKLEY_RSA_ENC:
+     case OAKLEY_RSA_ENC_REV:
+     case OAKLEY_DSS_SIG:
+     case OAKLEY_ELGAMAL_ENC:
+     case OAKLEY_ELGAMAL_ENC_REV:
+#endif
 	{
 	    pb_stream *const hash_pbs = &md->chain[ISAKMP_NEXT_HASH]->pbs;
 
@@ -1038,7 +1344,10 @@
 
     DBG_cond_dump(DBG_CRYPT | DBG_RAW, "encrypting:\n", enc_start, enc_len);
 
-    /* pad up to multiple of encryption blocksize */
+    /* Pad up to multiple of encryption blocksize.
+     * See the description associated with the definition of
+     * struct isakmp_hdr in packet.h.
+     */
     {
 	size_t padding = pad_up(enc_len, e->blocksize);
 
@@ -1163,12 +1472,12 @@
 }
 
 stf_status
-quick_outI1(
-	int whack_sock,
-	struct state *isakmp_sa,
-	struct connection *c,
-	lset_t policy,
-	unsigned long try)
+
+quick_outI1(int whack_sock
+, struct state *isakmp_sa
+, struct connection *c
+, lset_t policy
+, unsigned long try)
 {
     struct state *st = duplicate_state(isakmp_sa);
     u_char space[8192];	/* NOTE: we assume 8192 is big enough to build the packet */
@@ -1294,6 +1603,11 @@
     whack_log(RC_NEW_STATE + STATE_QUICK_I1
 	, "%s: initiate", enum_name(&state_names, st->st_state));
     cur_state = NULL;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_outI1");
+    );
+
     return STF_NO_REPLY;
 }
 
@@ -1308,6 +1622,15 @@
     pb_stream *const id_pbs = &id_pld->pbs;
     struct isakmp_id *const id = &id_pld->payload.id;
     struct id peer;
+    const u_int max_len = 512;
+
+#ifdef OPENSSL
+    u_char key_id[max_len];
+    u_int i, len;
+
+    peer.key_id.len = 0;
+    peer.der_asn1_dn.len = 0;
+#endif
 
     /* I think that RFC2407 (IPSEC DOI) 4.6.2 is confused.
      * It talks about the protocol ID and Port fields of the ID
@@ -1328,6 +1651,7 @@
 	return FALSE;
     }
 
+
     /* XXX Check for valid ID types? */
     peer.kind = id->isaid_idtype;
 
@@ -1361,9 +1685,9 @@
     case ID_FQDN:
 	if (memchr(id_pbs->cur, '\0', pbs_left(id_pbs)) != NULL)
 	{
-	    loglog(RC_LOG_SERIOUS, "Phase 1 ID Payload of type %s contains a NUL"
-		, enum_show(&ident_names, peer.kind));
-	    return FALSE;
+	  loglog(RC_LOG_SERIOUS, "Phase 1 ID Payload of type %s contains a NULL"
+	    ,enum_show(&ident_names, peer.kind));
+	  return FALSE;
 	}
 
 	/* ??? ought to do some more sanity check, but what? */
@@ -1371,6 +1695,76 @@
 	setchunk(peer.name, id_pbs->cur, pbs_left(id_pbs));
 	break;
 
+#ifdef OPENSSL
+    case ID_KEY_ID:
+	if (!(id->isaid_doi_specific_a == 0 && id->isaid_doi_specific_b == 0))
+	{
+	log("protocol/port in Phase 1 ID Payload must be 0/0"
+			" but are %d/%d"
+			, id->isaid_doi_specific_a, id->isaid_doi_specific_b);
+		return FALSE;
+	}
+
+	len = pbs_left(id_pbs);
+
+	/* we need double size for ASCII representation of key id */
+	if (2*len > max_len)
+	{
+		log("too large key id");
+		return FALSE;
+	}
+
+	DBG(DBG_PARSING,
+	DBG_dump("Received Key ID:", id_pbs->cur, pbs_left(id_pbs));
+	);
+
+	/* hold the binary representation of KEY_ID */
+	/* possible memory hole? */
+	peer.key_id.ptr = alloc_bytes(len, "key_id");
+	peer.key_id.len = len;
+	memcpy(peer.key_id.ptr, id_pbs->cur, len);
+
+	for (i=0; i<len; i++, id_pbs->cur++)
+		sprintf(&key_id[i*2], "%02x", *(id_pbs->cur));
+
+	peer.name.ptr = alloc_bytes(2*len, "name");
+	peer.name.len = 2*len;
+	memcpy(peer.name.ptr, key_id, peer.name.len);
+	break;  
+
+    case ID_DER_ASN1_DN:
+	if (!(id->isaid_doi_specific_a == 0 && id->isaid_doi_specific_b == 0))
+	{
+	log("protocol/port in Phase 1 ID Payload must be 0/0"
+			" but are %d/%d", id->isaid_doi_specific_a, 
+			id->isaid_doi_specific_b);
+		return FALSE;
+	}
+	len = pbs_left(id_pbs);
+
+	if (len > max_len)
+	{
+		log("too large DER ASN1 DN");
+		return FALSE;
+	}
+
+	if (id_pbs->cur == NULL) {
+		loglog(RC_LOG_SERIOUS, 
+			"ID_DER_ASN1_DN received, but is 0 length.");
+		return FALSE;
+	}
+
+	peer.der_asn1_dn.ptr = alloc_bytes(len,"der asn1 dn");
+	peer.der_asn1_dn.len = len;
+	memcpy(peer.der_asn1_dn.ptr, id_pbs->cur, len);
+
+	DBG(DBG_PARSING,
+	DBG_dump_chunk("Received peer.id (processed ID_DER_ASN1_DN):", 
+		peer.der_asn1_dn);       
+	);
+	break; 
+#endif OPENSSL
+
     default:
 	/* XXX Could send notification back */
 	loglog(RC_LOG_SERIOUS, "Unacceptable identity type (%s) in Phase 1 ID Payload"
@@ -1382,6 +1776,7 @@
     st->st_peeridentity_protocol = id->isaid_doi_specific_a;
     st->st_peeridentity_port = id->isaid_doi_specific_b;
 
+#if 0 /* Commented out because DER_AS1_DN creates LOTS of output here. */
     DBG(DBG_PARSING,
 	{
 	    char buf[IDTOA_BUF];
@@ -1391,6 +1786,7 @@
 		enum_show(&ident_names, id->isaid_idtype),
 		buf);
 	});
+#endif
 
     /* now that we've decoded the ID payload, let's see if we
      * need to switch connections.
@@ -1419,10 +1815,29 @@
 		/* instantiate it, filling in peer's ID */
 		r = rw_instantiate(r, &c->that.host_addr, &peer);
 	    }
+
 	    st->st_connection = r;	/* kill reference to c */
 	    SET_CUR_CONNECTION(r);
 	    connection_discard(c);
-	}
+
+      }
+#ifdef OPENSSL
+      /* if we have a binary key_id, set it now into conn */
+      if (peer.key_id.len)
+      {
+              r->that.id.key_id.ptr = clone_bytes(peer.key_id.ptr,
+                      peer.key_id.len, "KEY-ID");
+              r->that.id.key_id.len = peer.key_id.len;
+      }
+
+      /* if we have a binary der_asn1_dn, set it now into conn */
+      if (peer.der_asn1_dn.len)
+      {
+              r->that.id.der_asn1_dn.ptr = clone_bytes(peer.der_asn1_dn.ptr,
+                      peer.der_asn1_dn.len, "ID_DER_ASN1_DN");
+              r->that.id.der_asn1_dn.len = peer.der_asn1_dn.len;
+      }
+#endif /* OPENSSL */
     }
 
     return TRUE;
@@ -1432,6 +1847,7 @@
  * This is designed for packets that identify clients, not peers.
  */
 static bool
+
 decode_net_id(
     struct isakmp_ipsec_id *id,
     pb_stream *id_pbs,
@@ -1795,6 +2211,10 @@
 
     pb_stream r_sa_pbs;
 
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI1_outR1");
+    );
+
     if (c == NULL)
     {
 	/* see if a wildcarded connection can be found */
@@ -1872,12 +2292,17 @@
     }
 
     /* SA body in and out */
-    RETURN_STF_FAILURE(parse_isakmp_sa_body(&sa_pd->pbs, &sa_pd->payload.sa, &r_sa_pbs
-	    , FALSE, st));
+    RETURN_STF_FAILURE(parse_isakmp_sa_body(&sa_pd->pbs, 
+      &sa_pd->payload.sa, &r_sa_pbs, FALSE, st));
     close_message(&md->rbody);
 
     /* save initiator SA for HASH */
-    clonereplacechunk(st->st_p1isa, sa_pd->pbs.start, pbs_room(&sa_pd->pbs), "sa in main_inI1_outR1()");
+    clonereplacechunk(st->st_p1isa, sa_pd->pbs.start, 
+      pbs_room(&sa_pd->pbs), "sa in main_inI1_outR1()");
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI1_outR1");
+    );
 
     return STF_REPLY;
 }
